<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>SigGen: /home/x/siggen/lib/src/ThreadManagerPowerSaver.cpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
  $(document).ready(initResizable);
/* @license-end */</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">SigGen
   &#160;<span id="projectnumber">1.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('_thread_manager_power_saver_8cpp_source.html','');});
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">ThreadManagerPowerSaver.cpp</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#include &quot;ThreadManagerPowerSaver.h&quot;</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#include &quot;Logging.h&quot;</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#include &quot;InvalidBlockIndex.h&quot;</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#include &lt;exception&gt;</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="keyword">namespace </span>siggen {</div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160; </div>
<div class="line"><a name="l00008"></a><span class="lineno"><a class="line" href="classsiggen_1_1_thread_manager_power_saver.html#a2434e6d1fc566048154d81380065df1e">    8</a></span>&#160;    <a class="code" href="classsiggen_1_1_thread_manager_power_saver.html#a2434e6d1fc566048154d81380065df1e">ThreadManagerPowerSaver::ThreadManagerPowerSaver</a> (<a class="code" href="structsiggen_1_1_data.html">Data</a> &amp;&amp; data)</div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;        : <a class="code" href="classsiggen_1_1_thread_manager.html">ThreadManager</a>(std::move(data)) <span class="comment">// @NOTE: data is moved from here</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;        , m_Queue(m_Data.m_ThreadCount, m_Data.m_BlockSize)</div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;        , m_Signatures(m_Data.m_InputBlockCount, m_Data.m_Hash-&gt;GetSignatureSize())</div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;    {</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;        <span class="comment">// buffer for a block</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;        m_Block.resize(<a class="code" href="classsiggen_1_1_thread_manager.html#acf2e72bb7f780cd77fd9f046c5f8c66c">m_Data</a>.<a class="code" href="structsiggen_1_1_data.html#a1006e97814f7d32c8668575d56ba8bdf">m_BlockSize</a>);</div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160; </div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;        LOGMSG(debug) &lt;&lt; <span class="stringliteral">&quot;Spawning consumer threads&quot;</span>;</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;        <span class="keywordflow">for</span> (uint32_t t = 0; t &lt; <a class="code" href="classsiggen_1_1_thread_manager.html#acf2e72bb7f780cd77fd9f046c5f8c66c">m_Data</a>.<a class="code" href="structsiggen_1_1_data.html#a10d14f9813765c6f31080355bad10dbd">m_ThreadCount</a>; ++t)</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;        {</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;            m_Threads.push_back(std::thread(&amp;<a class="code" href="classsiggen_1_1_thread_manager_power_saver.html#a26a2a10c5fa543ea86c5058d69e0ee87">ThreadManagerPowerSaver::ConsumerThread</a>, <span class="keyword">this</span>, t));</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;        }</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;    }</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160; </div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;    ThreadManagerPowerSaver::~ThreadManagerPowerSaver ()</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;    {</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;        LOGMSG(debug) &lt;&lt; <span class="stringliteral">&quot;Destroying ThreadManagerPowerSaver&quot;</span>;</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    }</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160; </div>
<div class="line"><a name="l00028"></a><span class="lineno"><a class="line" href="classsiggen_1_1_thread_manager_power_saver.html#a26a2a10c5fa543ea86c5058d69e0ee87">   28</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classsiggen_1_1_thread_manager_power_saver.html#a26a2a10c5fa543ea86c5058d69e0ee87">ThreadManagerPowerSaver::ConsumerThread</a> (<span class="keywordtype">size_t</span> threadIndex)</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    {</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;        LOGSCOPE();</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160; </div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;        <span class="comment">// thread-local buffer for data</span></div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;        std::vector&lt;char&gt; threadBlock(<a class="code" href="classsiggen_1_1_thread_manager.html#acf2e72bb7f780cd77fd9f046c5f8c66c">m_Data</a>.<a class="code" href="structsiggen_1_1_data.html#a1006e97814f7d32c8668575d56ba8bdf">m_BlockSize</a>);</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;        <span class="comment">// thread-local buffer for result</span></div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;        std::vector&lt;char&gt; signature(<a class="code" href="classsiggen_1_1_thread_manager.html#acf2e72bb7f780cd77fd9f046c5f8c66c">m_Data</a>.<a class="code" href="structsiggen_1_1_data.html#a06a7600d0e0634bbb0275b81589fd5aa">m_Hash</a>-&gt;GetSignatureSize());</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160; </div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;        LOGMSG(debug) &lt;&lt; <span class="stringliteral">&quot;Consumer Thread_&quot;</span> &lt;&lt; threadIndex &lt;&lt; <span class="stringliteral">&quot; started, data=&quot;</span> &lt;&lt; (<span class="keywordtype">void</span>*)threadBlock.data();</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160; </div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;        <span class="keywordflow">while</span> (!m_Terminate.load())</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;        {</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;            LOGMSG(trace) &lt;&lt; <span class="stringliteral">&quot;Thread_&quot;</span> &lt;&lt; threadIndex &lt;&lt; <span class="stringliteral">&quot; entering another loop&quot;</span>;</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160; </div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;            <span class="comment">// get data or wait until there is any data</span></div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;            <span class="keywordtype">size_t</span> blockIndex = c_InvalidBlockIndex;</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;            m_Queue.<a class="code" href="classsiggen_1_1_m_t_queue.html#ab383d104dbf22cb80df5fa826c23573b">Dequeue</a>(blockIndex, threadBlock);</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160; </div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;            <span class="keywordflow">if</span> (blockIndex == c_InvalidBlockIndex)</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;            {</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;                LOGMSG(trace) &lt;&lt; <span class="stringliteral">&quot;Thread_&quot;</span> &lt;&lt; threadIndex &lt;&lt; <span class="stringliteral">&quot; dequeued -1, terminating&quot;</span>;</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;                <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;            }</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160; </div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;            <span class="comment">// hash</span></div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;            LOGMSG(trace) &lt;&lt; <span class="stringliteral">&quot;Thread_&quot;</span> &lt;&lt; threadIndex &lt;&lt; <span class="stringliteral">&quot; calculating signature for block=&quot;</span> &lt;&lt; blockIndex;</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;            <a class="code" href="classsiggen_1_1_thread_manager.html#acf2e72bb7f780cd77fd9f046c5f8c66c">m_Data</a>.<a class="code" href="structsiggen_1_1_data.html#a06a7600d0e0634bbb0275b81589fd5aa">m_Hash</a>-&gt;CalculateSignature(threadBlock.data(), threadBlock.size(), signature.data());</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160; </div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;            <span class="comment">// publish result</span></div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;            m_Signatures.<a class="code" href="classsiggen_1_1_m_t_signatures.html#a8c0c1ca006f51e67e167d9be74662a95">PostResult</a>(blockIndex, signature);</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;        }</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160; </div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;        LOGMSG(debug) &lt;&lt; <span class="stringliteral">&quot;Consumer Thread_&quot;</span> &lt;&lt; threadIndex &lt;&lt; <span class="stringliteral">&quot; terminated! data=&quot;</span> &lt;&lt; (<span class="keywordtype">void</span>*)threadBlock.data();</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;    }</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160; </div>
<div class="line"><a name="l00064"></a><span class="lineno"><a class="line" href="classsiggen_1_1_thread_manager_power_saver.html#ac96e31c7a171d9309dcb04b4232cec58">   64</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classsiggen_1_1_thread_manager_power_saver.html#ac96e31c7a171d9309dcb04b4232cec58">ThreadManagerPowerSaver::ProcessToBuffer</a> (std::vector&lt;char&gt; &amp; result)</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    {</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;        LOGSCOPE();</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160; </div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;        <span class="comment">// read blocks and enqueue</span></div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;        <span class="keywordtype">size_t</span> blockIndex = 0;</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;        <span class="keywordflow">while</span> (<span class="keywordtype">size_t</span> <span class="keyword">const</span> sz = <a class="code" href="classsiggen_1_1_thread_manager.html#acf2e72bb7f780cd77fd9f046c5f8c66c">m_Data</a>.<a class="code" href="structsiggen_1_1_data.html#a09582db7e870dfdd031c9076338384cb">m_InputFile</a>-&gt;TryRead(m_Block.data(), <a class="code" href="classsiggen_1_1_thread_manager.html#acf2e72bb7f780cd77fd9f046c5f8c66c">m_Data</a>.<a class="code" href="structsiggen_1_1_data.html#a1006e97814f7d32c8668575d56ba8bdf">m_BlockSize</a>))</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;        {</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;            LOGMSG(trace) &lt;&lt; <span class="stringliteral">&quot;---------------------------------------------------------------&quot;</span>;</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160; </div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;            <span class="keywordflow">if</span> (sz &lt; <a class="code" href="classsiggen_1_1_thread_manager.html#acf2e72bb7f780cd77fd9f046c5f8c66c">m_Data</a>.<a class="code" href="structsiggen_1_1_data.html#a1006e97814f7d32c8668575d56ba8bdf">m_BlockSize</a>)</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;            {</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;                LOGMSG(trace) &lt;&lt; (1 + blockIndex) &lt;&lt; <span class="stringliteral">&quot; / &quot;</span> &lt;&lt; <a class="code" href="classsiggen_1_1_thread_manager.html#acf2e72bb7f780cd77fd9f046c5f8c66c">m_Data</a>.<a class="code" href="structsiggen_1_1_data.html#aaf8091edab7f24f7b6f725f6abbacc23">m_InputBlockCount</a> &lt;&lt; <span class="stringliteral">&quot; Partial block size=&quot;</span> &lt;&lt; sz &lt;&lt; <span class="stringliteral">&quot; padding=&quot;</span> &lt;&lt; <a class="code" href="classsiggen_1_1_thread_manager.html#acf2e72bb7f780cd77fd9f046c5f8c66c">m_Data</a>.<a class="code" href="structsiggen_1_1_data.html#a1006e97814f7d32c8668575d56ba8bdf">m_BlockSize</a> - sz;</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;                memset(m_Block.data() + sz, 0, <a class="code" href="classsiggen_1_1_thread_manager.html#acf2e72bb7f780cd77fd9f046c5f8c66c">m_Data</a>.<a class="code" href="structsiggen_1_1_data.html#a1006e97814f7d32c8668575d56ba8bdf">m_BlockSize</a> - sz);</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;            }</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;            <span class="keywordflow">else</span></div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;            {</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;                LOGMSG(trace) &lt;&lt; (1 + blockIndex) &lt;&lt; <span class="stringliteral">&quot; / &quot;</span> &lt;&lt; <a class="code" href="classsiggen_1_1_thread_manager.html#acf2e72bb7f780cd77fd9f046c5f8c66c">m_Data</a>.<a class="code" href="structsiggen_1_1_data.html#aaf8091edab7f24f7b6f725f6abbacc23">m_InputBlockCount</a> &lt;&lt; <span class="stringliteral">&quot; Full block size=&quot;</span> &lt;&lt; sz;</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;            }</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160; </div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;            LOGMSG(trace) &lt;&lt; <span class="stringliteral">&quot;About to enqueue block from file&quot;</span>;</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;            m_Queue.<a class="code" href="classsiggen_1_1_m_t_queue.html#ac47b8a0a7ad4c4334dfed8596aea1651">Enqueue</a>(blockIndex, m_Block);</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160; </div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;            LOGMSG(trace) &lt;&lt; <span class="stringliteral">&quot;Enqueued, trying to read another block&quot;</span>;</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;            ++blockIndex;</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;        }</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160; </div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;        LOGMSG(trace) &lt;&lt; blockIndex &lt;&lt; <span class="stringliteral">&quot; / &quot;</span> &lt;&lt; <a class="code" href="classsiggen_1_1_thread_manager.html#acf2e72bb7f780cd77fd9f046c5f8c66c">m_Data</a>.<a class="code" href="structsiggen_1_1_data.html#aaf8091edab7f24f7b6f725f6abbacc23">m_InputBlockCount</a> &lt;&lt; <span class="stringliteral">&quot; last block, reading loop terminated&quot;</span>;</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160; </div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;        <span class="comment">// wait until all threads complete work</span></div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;        m_Signatures.<a class="code" href="classsiggen_1_1_m_t_signatures.html#ab926d14daa29ab9c4ff06ff8545e0b34">WaitForComplete</a>();</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160; </div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;        <span class="comment">// signalize terminate</span></div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;        LOGMSG(trace) &lt;&lt; <span class="stringliteral">&quot;Completed, terminating...&quot;</span>;</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;        m_Queue.<a class="code" href="classsiggen_1_1_m_t_queue.html#a70fe66d834087214efffe789fb296289">Terminate</a>();</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;        m_Terminate.store(<span class="keyword">true</span>);</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160; </div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;        <span class="comment">// join threads</span></div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;        <span class="keywordflow">for</span> (uint32_t t = 0; t &lt; <a class="code" href="classsiggen_1_1_thread_manager.html#acf2e72bb7f780cd77fd9f046c5f8c66c">m_Data</a>.<a class="code" href="structsiggen_1_1_data.html#a10d14f9813765c6f31080355bad10dbd">m_ThreadCount</a>; ++t)</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;            m_Threads[t].join();</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160; </div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;        <span class="comment">// copy signatures to result</span></div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;        result = m_Signatures.<a class="code" href="classsiggen_1_1_m_t_signatures.html#aefefb4578dd0a3af71eb81148fe9fa16">GetResult</a>();</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;    }</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160; </div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;} <span class="comment">// namespace siggen</span></div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160; </div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<div class="ttc" id="aclasssiggen_1_1_m_t_signatures_html_aefefb4578dd0a3af71eb81148fe9fa16"><div class="ttname"><a href="classsiggen_1_1_m_t_signatures.html#aefefb4578dd0a3af71eb81148fe9fa16">siggen::MTSignatures::GetResult</a></div><div class="ttdeci">const result_t &amp; GetResult() const</div><div class="ttdoc">get array with result signatures of each block of input</div><div class="ttdef"><b>Definition:</b> <a href="_m_t_signatures_8h_source.html#l00051">MTSignatures.h:51</a></div></div>
<div class="ttc" id="astructsiggen_1_1_data_html_aaf8091edab7f24f7b6f725f6abbacc23"><div class="ttname"><a href="structsiggen_1_1_data.html#aaf8091edab7f24f7b6f725f6abbacc23">siggen::Data::m_InputBlockCount</a></div><div class="ttdeci">size_t m_InputBlockCount</div><div class="ttdoc">block count (number of generated signatures)</div><div class="ttdef"><b>Definition:</b> <a href="_data_8h_source.html#l00016">Data.h:16</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_m_t_signatures_html_ab926d14daa29ab9c4ff06ff8545e0b34"><div class="ttname"><a href="classsiggen_1_1_m_t_signatures.html#ab926d14daa29ab9c4ff06ff8545e0b34">siggen::MTSignatures::WaitForComplete</a></div><div class="ttdeci">void WaitForComplete()</div><div class="ttdoc">waits on the condition until all threads deliver their result</div><div class="ttdef"><b>Definition:</b> <a href="_m_t_signatures_8cpp_source.html#l00031">MTSignatures.cpp:31</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_thread_manager_power_saver_html_a2434e6d1fc566048154d81380065df1e"><div class="ttname"><a href="classsiggen_1_1_thread_manager_power_saver.html#a2434e6d1fc566048154d81380065df1e">siggen::ThreadManagerPowerSaver::ThreadManagerPowerSaver</a></div><div class="ttdeci">ThreadManagerPowerSaver(Data &amp;&amp;data)</div><div class="ttdoc">spawns data.m_ThreadCount threads to do the work</div><div class="ttdef"><b>Definition:</b> <a href="_thread_manager_power_saver_8cpp_source.html#l00008">ThreadManagerPowerSaver.cpp:8</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_thread_manager_power_saver_html_ac96e31c7a171d9309dcb04b4232cec58"><div class="ttname"><a href="classsiggen_1_1_thread_manager_power_saver.html#ac96e31c7a171d9309dcb04b4232cec58">siggen::ThreadManagerPowerSaver::ProcessToBuffer</a></div><div class="ttdeci">virtual void ProcessToBuffer(std::vector&lt; char &gt; &amp;result) override</div><div class="ttdoc">reads a block of data from input file, and enqueues the data for further processing by threads</div><div class="ttdef"><b>Definition:</b> <a href="_thread_manager_power_saver_8cpp_source.html#l00064">ThreadManagerPowerSaver.cpp:64</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_thread_manager_html"><div class="ttname"><a href="classsiggen_1_1_thread_manager.html">siggen::ThreadManager</a></div><div class="ttdoc">common implementation of a ThreadManager base</div><div class="ttdef"><b>Definition:</b> <a href="_thread_manager_8h_source.html#l00011">ThreadManager.h:11</a></div></div>
<div class="ttc" id="astructsiggen_1_1_data_html_a06a7600d0e0634bbb0275b81589fd5aa"><div class="ttname"><a href="structsiggen_1_1_data.html#a06a7600d0e0634bbb0275b81589fd5aa">siggen::Data::m_Hash</a></div><div class="ttdeci">std::unique_ptr&lt; HashBase &gt; m_Hash</div><div class="ttdoc">signature function</div><div class="ttdef"><b>Definition:</b> <a href="_data_8h_source.html#l00020">Data.h:20</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_m_t_queue_html_ac47b8a0a7ad4c4334dfed8596aea1651"><div class="ttname"><a href="classsiggen_1_1_m_t_queue.html#ac47b8a0a7ad4c4334dfed8596aea1651">siggen::MTQueue::Enqueue</a></div><div class="ttdeci">void Enqueue(size_t blockIndex, std::vector&lt; char &gt; &amp;data)</div><div class="ttdoc">enqueues data or waits</div><div class="ttdef"><b>Definition:</b> <a href="_m_t_queue_8cpp_source.html#l00018">MTQueue.cpp:18</a></div></div>
<div class="ttc" id="astructsiggen_1_1_data_html_a1006e97814f7d32c8668575d56ba8bdf"><div class="ttname"><a href="structsiggen_1_1_data.html#a1006e97814f7d32c8668575d56ba8bdf">siggen::Data::m_BlockSize</a></div><div class="ttdeci">size_t m_BlockSize</div><div class="ttdoc">block size specified from options</div><div class="ttdef"><b>Definition:</b> <a href="_data_8h_source.html#l00014">Data.h:14</a></div></div>
<div class="ttc" id="astructsiggen_1_1_data_html_a10d14f9813765c6f31080355bad10dbd"><div class="ttname"><a href="structsiggen_1_1_data.html#a10d14f9813765c6f31080355bad10dbd">siggen::Data::m_ThreadCount</a></div><div class="ttdeci">uint32_t m_ThreadCount</div><div class="ttdoc">thread count</div><div class="ttdef"><b>Definition:</b> <a href="_data_8h_source.html#l00017">Data.h:17</a></div></div>
<div class="ttc" id="astructsiggen_1_1_data_html"><div class="ttname"><a href="structsiggen_1_1_data.html">siggen::Data</a></div><div class="ttdoc">provides threading manager with necessary data to work with</div><div class="ttdef"><b>Definition:</b> <a href="_data_8h_source.html#l00012">Data.h:12</a></div></div>
<div class="ttc" id="astructsiggen_1_1_data_html_a09582db7e870dfdd031c9076338384cb"><div class="ttname"><a href="structsiggen_1_1_data.html#a09582db7e870dfdd031c9076338384cb">siggen::Data::m_InputFile</a></div><div class="ttdeci">std::unique_ptr&lt; File &gt; m_InputFile</div><div class="ttdoc">input file (binary)</div><div class="ttdef"><b>Definition:</b> <a href="_data_8h_source.html#l00019">Data.h:19</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_m_t_signatures_html_a8c0c1ca006f51e67e167d9be74662a95"><div class="ttname"><a href="classsiggen_1_1_m_t_signatures.html#a8c0c1ca006f51e67e167d9be74662a95">siggen::MTSignatures::PostResult</a></div><div class="ttdeci">void PostResult(size_t blockIndex, result_t const &amp;blockSignature)</div><div class="ttdoc">posting result from another thread</div><div class="ttdef"><b>Definition:</b> <a href="_m_t_signatures_8cpp_source.html#l00014">MTSignatures.cpp:14</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_thread_manager_power_saver_html_a26a2a10c5fa543ea86c5058d69e0ee87"><div class="ttname"><a href="classsiggen_1_1_thread_manager_power_saver.html#a26a2a10c5fa543ea86c5058d69e0ee87">siggen::ThreadManagerPowerSaver::ConsumerThread</a></div><div class="ttdeci">void ConsumerThread(size_t threadIndex)</div><div class="ttdoc">basic loop for spawned consumer threads</div><div class="ttdef"><b>Definition:</b> <a href="_thread_manager_power_saver_8cpp_source.html#l00028">ThreadManagerPowerSaver.cpp:28</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_m_t_queue_html_a70fe66d834087214efffe789fb296289"><div class="ttname"><a href="classsiggen_1_1_m_t_queue.html#a70fe66d834087214efffe789fb296289">siggen::MTQueue::Terminate</a></div><div class="ttdeci">void Terminate()</div><div class="ttdoc">sets terminate flag and notify waiting thread(s)</div><div class="ttdef"><b>Definition:</b> <a href="_m_t_queue_8cpp_source.html#l00074">MTQueue.cpp:74</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_thread_manager_html_acf2e72bb7f780cd77fd9f046c5f8c66c"><div class="ttname"><a href="classsiggen_1_1_thread_manager.html#acf2e72bb7f780cd77fd9f046c5f8c66c">siggen::ThreadManager::m_Data</a></div><div class="ttdeci">Data m_Data</div><div class="ttdoc">configuration for a thread manager</div><div class="ttdef"><b>Definition:</b> <a href="_thread_manager_8h_source.html#l00014">ThreadManager.h:14</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_m_t_queue_html_ab383d104dbf22cb80df5fa826c23573b"><div class="ttname"><a href="classsiggen_1_1_m_t_queue.html#ab383d104dbf22cb80df5fa826c23573b">siggen::MTQueue::Dequeue</a></div><div class="ttdeci">void Dequeue(size_t &amp;blockIndex, std::vector&lt; char &gt; &amp;data)</div><div class="ttdoc">dequeues data or waits</div><div class="ttdef"><b>Definition:</b> <a href="_m_t_queue_8cpp_source.html#l00042">MTQueue.cpp:42</a></div></div>
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_97aefd0d527b934f1d99a682da8fe6a9.html">lib</a></li><li class="navelem"><a class="el" href="dir_a065c5f60305fee3569f887679366939.html">src</a></li><li class="navelem"><b>ThreadManagerPowerSaver.cpp</b></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.16 </li>
  </ul>
</div>
</body>
</html>
